import 'package:blocstar/DataManagement/Mergeable.dart';
import 'package:flutter/material.dart';

import 'ActionState.dart';

abstract class BlocContextBase<TBlocContext>
    implements Mergeable<TBlocContext> {
  ActionState actionState;
  final Function(TBlocContext updatedContext) onContextChanged;

  BlocContextBase(this.onContextChanged) {
    actionState = new ActionState(
        false, false, null, () => onContextChanged(this as TBlocContext));
    onContextChanged(this as TBlocContext);
  }

  @protected
  BlocContextBase<TBlocContext> mergeAppState(
      BlocContextBase<TBlocContext> newModel) {
    newModel.actionState =
        new ActionState(false, false, null, actionState.onActionStateChanged);
    return newModel;
  }
}
