import 'package:blocstar/ActionState.dart';
import 'package:flutter_test/flutter_test.dart';

import 'BlocModel.dart';

void main() {
  test("busy state triggers ActionState", () {
    var busy = false;
    final context = new BlocModel((ctx) {
      busy = ctx.actionState.busy;
    });

    context.actionState.busy = true;
    expect(busy, true);
  });

  test("last action timeout triggers ActionState", () {
    var lastActionTimeOut = false;
    final context = new BlocModel((ctx) {
      lastActionTimeOut = ctx.actionState.lastActionTimedOut;
    });

    context.actionState.lastActionTimedOut = true;
    expect(lastActionTimeOut, true);
  });

  test("last action exception triggers ActionState", () {
    final exceptionMessage = "blah";
    Exception lastException;
    final context = new BlocModel((ctx) {
      lastException = ctx.actionState.lastActionException;
    });

    context.actionState.lastActionException = new Exception(exceptionMessage);
    expect(lastException != null, true);
  });
}
